Subject: bug#77137: package.el computes false-positive obsolete statuses

From: Ship Mints <[email-masked]>
Date: Sat, 10 May 2025 07:36:52 -0400

On Thu, Mar 20, 2025 at 11:51 AM Ship Mints <[email-masked]> wrote:

> Example, using the situation in
> https://debbugs.gnu.org/cgi/bugreport.cgi?bug=77134 where I have
> "dirvish" installed from both non-GNU ELPA and MELPA, claims that MELPA is
> obsolete when it is actually the more recent version.  Not having dived
> deep, I see two potential areas of false positives in the code.  One is
> comparing incompatible version numbers from differing archive sources;
> e.g., non-GNU ELPA says "2.2.7" while MELPA says "20250319.1508".  The
> other suggests unsigned packages have lower precedence than signed packages
> independent of their recency.  Again, these could be wrong but I looked
> only for a minute.
>

It would be good to refine package.el's computation and handling of
"obsolete" packages.

-Stephane